from SimPy.Simulation import *
from random import *
import pickle
import datetime
import time
import rpy 

""" algotrading.py
    VERSION 6.3.
    how the decide the price in the proposal <-- uniform (0,0.001) instead of 0.01
    the chartist observe pl, which is formed with a process that insert the current price every 1 second
    NEW CHARTST Strategy <-- double moving average!
    reduced probability of buy/selling from 0.5 to 0.2
    more fundamentalists than chartists

    NEW: The chartists' signal occur when the short ma cross the long ma.
    they take the position and leave it when the opposite signal accurs.
    The signal is not continous!!!
    The news arrive at period 14000 --> all fundamentalist rise their fundametal
    price from around 100 to around 105.

    Changed Compatible proposal method adding != proponent. If traders want to buy at price p, and have made previously a proposal with a
    selling price less then p (which is still in the book) he will remove that proposal. And viceversa!
"""
##Data:step

nTraderF= 1000         ## number of fundamentalist
nTraderC= 300         ## number of chartists  
tInter = 300         ## traders trade every 5 minutes  
tMarket=30            ## observe the price in tb   
initialSeed=123456
simTime= 28800          #one day 8*60*60 seconds
startingprice=100
traderFList = []      ## i am going to put here all my fundamentalist traders
traderCList = []      ## here are all the chartist traders

dtickPrice = []
tickPrice = []       ## list used by the robotrader. The price here is recorded tick by tick!
tickPrice100 = []    ## list of last 100 executed prices. Robotrading use it to see if something is changing in the process
pl = []              ## list used by chartist to compute the moving average (la mettiamo dentro ts? the Buffer di ts è la lista di tutte le proposte accettate)
for i in range(5000):
    pl.append(startingprice+normalvariate(0,1))  ## create a fake initial price history with all 100 (starting price) 

lastTicks=[]
## -------------------------------------------------
## We use three processes: StockMarket, TraderF and traderC
## To do: ADD Market Maker, money and shares to traders
## -------------------------------------------------
## StockMarket write current price in tb (a TradingBlackboard), which is the last executed price
## StockMarket use three stores tdbuy tdsell, ts. td(buy/sell) for Proposals. ts for Accepted proposal (contracts)
## The StockMarket search for compatible proposals in tdBuy and tdSell.
## -------------------------------------------------
##
## Proposal is the first step in contract definition
## agents put buy-proposals into tdBuy and sell-proposal in tdSell
## Stock Market search for compatible proposals. If it finds them he puts the oldest proposal in ts... it becomes the contract.
 

class printPrice(Process): ## I use this process only to print stuff every 60 seconds
    def __init__(self):
        Process.__init__(self)
        self.oldTsBuffered = 0     #to compute the volume of trade every tMarket seconds
        self.volume = 0
        
    def go(self):
      while True:
        
        yield hold, self, tMarket
        #print "Trading state ---", now(), tdSell.nrBuffered, tdBuy.nrBuffered, ts.nrBuffered, tb.aprice
        price = tb.aprice
        #record the price only every 60 seconds, we have only 480 observation
        #instead of 6000
        
        
        ## to compute volatility I sum the returns of the last tMarket
        s = 0
        for i in lastTicks:
            s += abs(i)
        
        lastTicks[:] = []

        datalist= []
        self.volume = ts.nrBuffered - self.oldTsBuffered
        self.oldTsBuffered = ts.nrBuffered
        
        datalist.append(now())
        datalist.append(tb.aprice)
        datalist.append(self.volume)
        datalist.append(s)
        pm.observe(datalist)  ##to write to file
        pp.observe(price)    ##to compute variance and mean price


        if now()%180 == 0:
            print now()* 288**-1, '%'
        
        
        
        
        
class PlList(Process):  ## insert p in pl for chartists
    
    def go(self):
        while True:
            yield hold, self, 1
            pl.insert(0, tb.aprice)

        
class ErasingOldProposals(Process):
    def __init__(self):
        Process.__init__(self)

    def go(self):
        while True:
            yield hold, self, 500

            ## search for old proposals
            oldSell = []
            for i in tdSell.theBuffer:
                if now()-i.t > 1000:
                    oldSell.append(i)
            oldBuy = []
            for i in tdBuy.theBuffer:
                if now()-i.t > 1000:
                    oldBuy.append(i)
            
            
            yield (get, self, tdSell, oldSell),(hold, self, 100)
            yield (get, self, tdBuy, oldBuy),(hold, self, 100)
            
        

class Proposal:
    ## Proposal is the first step in contract definition
    ## agents put proposals into the book. 
    
    def __init__(self,owner,sellbuyflag,money, time):
        self.o=owner
        self.sbf=sellbuyflag
        self.m=money
        self.t=time
      
class Contract:
    ## accepted proposals become contracts,
    ## we use the data of the accepted proposals +
    ## the owner of the trader who accepts the proposal.
    ## we put the contract in ts
    def __init__(self, seller, buyer, money, time):
        self.seller = seller
        self.buyer = buyer
        self.price = money
        self.time = time
        
## Blackboards  ------------------------------------
## -------------------------------------------------       
class TradingBlackboard:
    def __init__(self):
        self.aprice=startingprice
        self.oldprice=self.aprice
        
 
## Starting PROCESS !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
## ----------------------------------------------------- 
## (1) STOCK MARKET. set blackboards from tradingstore   
class StockMarket(Process):
    def __init__(self,name):
        Process.__init__(self,name)
        
    def lifecycle(self, proposalEvent):
        while True:
            
            ## Functions that search for a compatible buy/sell proposal in the book, when a new proposal arrives

            def compatibleSellProposal(self, buyprice, proponent):
                'find a compatible sell proposal'
                result = []
                if len(tdSell.theBuffer)>0:
                    
                ## since the book is ordered and the quantity is always one, we just need
                ## to compare the buyprice with the first sell price in the book
                    if buyprice > tdSell.theBuffer[0].m:
                        result.append(tdSell.theBuffer[0])
                
                return result

            def compatibleBuyProposal(self,sellprice, proponent):
                'find a compatible buy proposal'
                result = []
                if len(tdBuy.theBuffer)>0:
                    if sellprice < tdBuy.theBuffer[0].m:
                        result.append(tdBuy.theBuffer[0])

                return result

            
                
            ## when a new proposal arrive the SM search for compatible proposals
                    
            yield waitevent,self, proposalEvent 
            proposal = proposalEvent.signalparam ## the stock market read the message in the buy event (the proposal!)

            
            
            if proposal.sbf == 1: ## it is a BUY PROPOSAL
                 buyprice = proposal.m ## max buy price. we are searching for smaller sell prices.
                 result = compatibleSellProposal(self, buyprice, proposal.o) ##the result is an empty list if there are no compatible proposal,
                                                            ##and a list with one element if there is a compatible proposal
                 if len(result)>0: ##the stock market found a compatible sell proposal
                    proposal2 = result[0]
                    
                    ## the contract is proposal two + the buyer
                    contract = Contract(proposal2.o, proposal.o, proposal2.m, now()) ##The contract has the seller, the buyer, the price and the time
                    contractEvent.signal()
                    
                    ## register the price for the robotrader, both here abd in the sell proposal event
                    tickPrice.append(proposal2.m)
                    a = 0
                    if len(tickPrice)>1:
                        a = (tickPrice[len(tickPrice)-1]-tickPrice[len(tickPrice)-2])*tickPrice[len(tickPrice)-2]**-1
                        dtickPrice.append(a)
                        tickRM.observe(a)
                        lastTicks.append(a)

                    tickM.observe(proposal2.m)
                    

                   
                    if len(dtickPrice)>2000:
                        dtickPrice.pop(0)
                        
                    yield put, self, ts, [contract]
                    
                    tb.aprice = contract.price ## the price of the last executed proposal, equivalent to proposal2.m
                    updateTraders(contract) ## update traders in the contract
                    
                    ## Erase the proposal from the book. it is the first in the list for construction.
                    yield get, self, tdSell, 1#tdSell.theBuffer.remove(proposal2)#yield get, self, tdSell, 1#[proposal2]

                 else: ## if SM cannot find any compatible proposal, it puts it in the book!
                     yield put,self,tdBuy, [proposal]

            else: ## it is a SELL PROPOSAL
                sellprice = proposal.m
                result = compatibleBuyProposal(self, sellprice, proposal.o)
                
                if len(result)>0:
                    proposal2 = result[0]
                    contract = Contract(proposal.o, proposal2.o, proposal2.m,now())  
                    contractEvent.signal()

                    tickPrice.append(proposal2.m)
                    a = 0
                    if len(tickPrice)>1:
                        a = (tickPrice[len(tickPrice)-1]-tickPrice[len(tickPrice)-2])*tickPrice[len(tickPrice)-2]**-1
                        dtickPrice.append(a)
                        tickRM.observe(a)
                        lastTicks.append(a)
                        
                    tickM.observe(proposal2.m)
                    
                                       
                                            
                    if len(dtickPrice)>2000:
                        dtickPrice.pop(0)

                    yield put, self, ts, [contract]

                    tb.aprice = contract.price
                    updateTraders(contract)
                    
                    
                    yield get, self, tdBuy, 1#tdBuy.theBuffer.remove(proposal2)

                else:
                    yield put,self,tdSell,[proposal]
                          

            
            

                
                        
            tdsm.observe([now(), tdSell.nrBuffered, tdBuy.nrBuffered , ts.nrBuffered, tb.aprice])
            
            
            
            sellBook=[]
            
            for i in tdSell.theBuffer:
                sellBook.append(i.m)
            
            buyBook=[]
            for i in tdBuy.theBuffer:
                buyBook.append(i.m)
            datalist=[]
            datalist.append(sellBook)
            datalist.append(buyBook)
            datalist.append(tb.aprice)
            datalist.append(now())
            bookM.observe(datalist)
            
            
## (2) Trader FUNDAMENTALIST ------------------------------
## --------------------------------------------------------
class TraderF(Process):
    
    def __init__(self,name,indexname):
        Process.__init__(self,name)
        self.indn=indexname
        self.pf=startingprice + normalvariate(0,1)
        self.money = 100000 ## starting cash 
        self.equity = 10000 ## starting shares
        self.buy = 0
        self.sell = 0
        self.tradertype=1
        self.wealth=self.money + self.equity * 100 ## initial wealth of the agents
        self.settime=now()
        self.newsupdate=-1
        
    
    
    def tradtime(self):
        return expovariate(1.0/tInter)

        
    
    def lifecycle(self):
        def donothing(self):
            donobuffer=-1
    
        while True:
            
            yield hold, self, self.tradtime()
        ## setting behavior -------------
            behavior=random();
            
            ## Agent sends the proposals to the Stock Market
            ## pf is the fundamentalist price
            ## tb.aprice is the price on the blackboard
            ## if pf > aprice buy proposal, else sell proposal
            if behavior < 0.20:
                 
                if self.pf > tb.aprice and self.money > tb.aprice: ## buy proposal. The price is the best proposal in the book + max 1%
                    if len(tdBuy.theBuffer) > 0:
                        theprice = tdBuy.theBuffer[0].m + uniform(0, 0.001)* tdBuy.theBuffer[0].m
                    else:
                        theprice = pl[0] ## if there are no buy proposals the trader put the price equal to the last executed price.
                    myproposal=Proposal(self,1,theprice, now())

                    uncompatibleProposal=[]
                    for i in tdSell.theBuffer: ## controlla se nel book di vendita ha messo proposal con un prezzo inferiore a quello a cui
                                              ## e' disposto a vendere. Nel caso rischierebbe di vendere ad un prezzo inferiore a quello a cui vuole comprare
                        if i.m < myproposal.m and myproposal.o == i.o:
                            uncompatibleProposal.append(i)

                    for i in uncompatibleProposal:  
                            tdSell.theBuffer.remove(i)
                    
                    proposalEvent.signal(myproposal) ## here the trader is sending the proposal to the stock market to be processed
                     
                if self.pf < tb.aprice and self.equity > 0: ## sell proposal. Best sell proposal minus a small quantity
                
                    if len(tdSell.theBuffer)>0:
                        theprice = tdSell.theBuffer[0].m - uniform(0,0.001)* tdSell.theBuffer[0].m
                    else:
                        theprice = pl[0] 
                    myproposal=Proposal(self,-1,theprice, now())
                    
                    uncompatibleProposal = []
                    for i in tdBuy.theBuffer: ## controlla se nel book di acquisto ha messo proposal con un prezzo superiore a quello a cui
                                              ## e' disposto a vendere. Nel caso rischierebbe di comprare ad un prezzo superiore a quello a cui vuole vendere
                        if i.m > myproposal.m and myproposal.o == i.o:
                            uncompatibleProposal.append(i)

                    for i in uncompatibleProposal:        
                        tdBuy.theBuffer.remove(i)
                            
                    proposalEvent.signal(myproposal)
            
                        
                    
                    
                    
            
            elif behavior > 0.20 and behavior < 0.75:
                ## print "Update Status"
                self.settime=now()
                self.wealth = self.money + self.equity * tb.aprice 
                datalist=[]
                datalist.append(self.indn)
                datalist.append(self.pf)
                datalist.append(self.equity)
                datalist.append(self.money)
                datalist.append(self.tradertype)
                datalist.append(self.buy)
                datalist.append(self.sell)
                datalist.append(self.wealth)
                datalist.append(self.settime)
                am.observe(datalist)
            
            elif behavior > 0.75:
                ## print "Update behavior"
                self.pf=self.pf+normalvariate(0,1)
                
                if now()>14000:
                    if self.newsupdate < 0:
                        self.newsupdate = 1
                        
                        if normalvariate(0,1) > -100:
                            
                            self.pf=self.pf+0+normalvariate(0,1)
                            
                       
                else:
                    self.pf=self.pf
            
            

                
            
            

class TraderFGenerator(Process):
    def generate(self):
        i=0
        
        for i in range(nTraderF):
            yield hold,self,uniform(1,2)
            c=TraderF("trader%s"%i,i)
            traderFList.append(c)
            activate(c,c.lifecycle())
            
        

## (3)    CHARTIST TRADER -----------------------------------------------

## chartist trader for stockmarket. The chartist trader compute a moving average over the prices of length L. If the price is above the MA he buys, if it is below he sells.
## the difference between chartist and fundamentalist is ONLY how they decide to buy or to sell
class TraderC(Process):
    
    def __init__(self,name,indexname):
        Process.__init__(self,name)
        self.indn=indexname
        self.L = 100 ##
        self.money = 100000 ## starting cash 
        self.equity = 10000 ## starting shares
        self.buy = 0 ## to record number of buys
        self.sell = 0 ## to record the number of sells
        self.tradertype= 2 
        self.wealth=self.money + self.equity * 100 ## initial wealth of the agents
        self.settime = now()
        self.differenceMa = 0
        self.signal = 0
        
    
    
    def tradtime(self):
        return expovariate(1.0/tInter)

   
    
            
    
    def lifecycle(self):
        def donothing(self):
            donobuffer=-1
        
               
        while True:
            
            yield hold, self, self.tradtime()
        ## setting behavior -------------
            behavior=random();
            
            
            ## Agent compute the moving average
            ## decide to buy or to sell looking at the
            ## market price and the ma
            
            if behavior < 0.20:
                self.signal = signal(self, pl)  

                if self.signal > 0 and self.money > tb.aprice: ## buy proposal. The price is the best proposal in the book + max 5%
                    #print self.signal, 'buy'
                    if len(tdBuy.theBuffer) > 0:
                    
                        theprice = tdBuy.theBuffer[0].m + uniform(0, 0.001)* tdBuy.theBuffer[0].m
                    else:
                        theprice = pl[0] ## if there are no buy proposals the trader put the price equal to the last executed price.
                    myproposal=Proposal(self,1,theprice, now())

                    uncompatibleProposal=[]
                    for i in tdSell.theBuffer: ## controlla se nel book di vendita ha messo proposal con un prezzo inferiore a quello a cui
                                              ## e' disposto a vendere. Nel caso rischierebbe di vendere ad un prezzo inferiore a quello a cui vuole comprare
                        if i.m < myproposal.m and myproposal.o == i.o:
                            uncompatibleProposal.append(i)

                    for i in uncompatibleProposal:  
                            tdSell.theBuffer.remove(i)

                    proposalEvent.signal(myproposal)
                     
                if self.signal < 0 and self.equity > 0: ## sell proposal. Best sell proposal minus a small quantity
                    #print self.signal, 'sell'
                    if len(tdSell.theBuffer)>0:
                        theprice = tdSell.theBuffer[0].m - uniform(0,0.001)* tdSell.theBuffer[0].m
                    else:
                        theprice = pl[0] 
                    myproposal=Proposal(self,-1,theprice, now())

                    uncompatibleProposal = []
                    for i in tdBuy.theBuffer: ## controlla se nel book di acquisto ha messo proposal con un prezzo superiore a quello a cui
                                              ## e' disposto a vendere. Nel caso rischierebbe di comprare ad un prezzo superiore a quello a cui vuole vendere
                        if i.m > myproposal.m and myproposal.o == i.o:
                            uncompatibleProposal.append(i)

                    for i in uncompatibleProposal:        
                        tdBuy.theBuffer.remove(i)
                            
                    proposalEvent.signal(myproposal)
                    
                        
                    
                    
                    
            
            elif behavior > 0.20:
                ## print "Update Status"
                self.settime=now()
                self.wealth = self.money + self.equity * tb.aprice 
                datalist=[]
                datalist.append(self.indn)
                datalist.append(self.signal)
                datalist.append(self.equity)
                datalist.append(self.money)
                datalist.append(self.tradertype)
                datalist.append(self.buy)
                datalist.append(self.sell)
                datalist.append(self.wealth)
                datalist.append(self.settime)
                am.observe(datalist)

            
                

            
            
                
            
            

class TraderCGenerator(Process):
    def generate(self):
        i=0
        
        for i in range(nTraderC):
            yield hold,self,uniform(1,2)
            c=TraderC("trader%s"%i,i + nTraderF + 1) ## the name of the chartist starts from the last fundamentalist
            traderCList.append(c)
            activate(c,c.lifecycle())


####################################################IL ROBOTRADER############
            ######### price process driven!##########à
##il robotrader raccoglie le informazioni tick per tick. Ogni volta che un contratto si forma
##inserisce il nuovo prezzo tra le sue informazioni.


class RoboTrader(Process):

    def __init__(self,name):
        Process.__init__(self,name)
        self.indn='RoboTrader'

        self.money = 100000 ## starting cash --> TO DO UPDATER after a contract
        self.equity = 10000 ## starting shares
        self.buy = 0 ## to record number of buys
        self.sell = 0 ## to record the number of sells
        self.tradertype= 3 
        self.wealth=self.money + self.equity * 100 ## initial wealth of the agents
        self.settime = now()
        self.trade = False
        self.arCoefficient =[] ## the robotrader puts here the Ar coefficient he estimates
        
        self.nextReturn=0
        self.totalSignals = 0
        self.sig = 0
        self.bench=0
        self.signal = 0
        self.benchmark = 0
        '''

         idea: il robotrader stima il processo stocastico del prezzo. Dato questo stima l'andamento del prezzo per i prossimi tot periodi usa la correlazione tra i periodi!. Se stima un rialzo (consistente)
        compra una azione e la rivende nel periodo in cui stima che il prezzo smette di aumentare (rispetto al prezzo di acquisto non in generale). Se stima
         una riduzione (consistente) vende una azione e la ricompra quando nel periodo in cui stima che il prezzo smette di scendere.
         ogni volta registra se la sua strategia ha avuto successo, quando ha più fallimenti del solito smette e ricalcola il processo.

         Può calcolare se il processo è stazionario e la sua media. Se per un dato periodo non è stazionario stiamo transitando verso una nuova media (?) NOTIZIA!
         Inoltre se si trova davanti un processo white noise, non scambia, perché non sa dove il prezzo andrà domani!
        '''

    def lifecycle(self, contractEvent):
       
       while True: 
         yield waitevent, self, contractEvent  ## agisce ogni volta che si conclude
         #yield hold, self, 1
         ## agisce solo se ha un processo di cui si fida (ossia se self.trade = True). Diventa true quando ha stimato il processo su almento [100] prezzi
         if len(dtickPrice) < 1000:
             self.trade = False
         else:
             self.trade=True 


         self.signal1 = self.signal
         self.benchmark1 = self.benchmark

         self.computePriceProcess(dtickPrice)
          
                 
         
         
             #print self.nextReturn, tickPrice[len(tickPrice)-1]
         if self.signal > 0 and self.money > tb.aprice: ## buy proposal. The price is the best proposal in the book + max 5%
                    #print self.signal, 'buy'
                    if len(tdBuy.theBuffer) > 0:
                    
                        theprice = tdBuy.theBuffer[0].m + uniform(0, 0.001)* tdBuy.theBuffer[0].m
                    else:
                        theprice = pl[0] ## if there are no buy proposals the trader put the price equal to the last executed price.
                    myproposal=Proposal(self,1,theprice, now())

                    uncompatibleProposal = []
                    for i in tdSell.theBuffer: ## controlla se nel book di vendita ha messo proposal con un prezzo inferiore a quello a cui
                                              ## e' disposto a vendere. Nel caso rischierebbe di vendere ad un prezzo inferiore a quello a cui vuole comprare
                        if i.m < myproposal.m and myproposal.o == i.o:
                            uncompatibleProposal.append(i)

                    for i in uncompatibleProposal:  
                            tdSell.theBuffer.remove(i)
                            
                    proposalEvent.signal(myproposal)
                     
         if self.signal < 0 and self.equity > 0: ## sell proposal. Best sell proposal minus a small quantity
                    #print self.signal, 'sell'
                    if len(tdSell.theBuffer)>0:
                        theprice = tdSell.theBuffer[0].m - uniform(0,0.001)* tdSell.theBuffer[0].m
                    else:
                        theprice = pl[0] 
                    myproposal=Proposal(self,-1,theprice, now())


                    uncompatibleProposal = []
                    for i in tdBuy.theBuffer: ## controlla se nel book di acquisto ha messo proposal con un prezzo superiore a quello a cui
                                              ## e' disposto a vendere. Nel caso rischierebbe di comprare ad un prezzo superiore a quello a cui vuole vendere
                        if i.m > myproposal.m and myproposal.o == i.o:
                            uncompatibleProposal.append(i)

                    for i in uncompatibleProposal:        
                        tdBuy.theBuffer.remove(i)
                            
                    proposalEvent.signal(myproposal)
         
         

         
    def computePriceProcess(self, dtickPrice):

        
               
        if self.trade == True:
            #print now()
            ## estimate the ar on the whole price list
            rpy.r.assign('dtickPriceR', dtickPrice)
            rpy.r('dtickPriceR<-ts(dtickPriceR)')
            estimatedAR = rpy.r('a <-ar(dtickPriceR)')
            self.arCoefficient = estimatedAR['ar']
            #print self.arCoefficient
            ## estimate the ar on the last 100 returns. if the mean changes a lot--< NEWS

            
            self.benchmark = normalvariate(0,1)
            self.totalSignals +=1
         ## if the robot was right then signal1 and last dtickPrice should be of the same sign!
            if self.signal1 * dtickPrice[len(dtickPrice)-1] > 0:
               self.sig += 1
            if self.benchmark1 * dtickPrice[len(dtickPrice)-1] > 0:
                self.bench +=1
            self.nextReturn = 0
            if self.arCoefficient > 10: ## if it is a list it is greater than a number 
             for i in range(len(self.arCoefficient)):
                self.nextReturn += self.arCoefficient[i]*dtickPrice[len(dtickPrice)-1-i]

            else:
                self.nextReturn = self.arCoefficient*dtickPrice[len(dtickPrice)-1]

            self.signal = self.nextReturn## if positive price should rise <-- positive return is expected!
            #self.signal = self.benchmark    

            
            
            
        ## if self.trade = False, signal = 0 --> do not trade
        else:
            self.signal = 0
        
## (4)    The function that orders the book.

def buyOrder(self,par):
    "it orders the buy side of the book from the highest price to the lowest"
    tmplist = [(x.m,x) for x in par]
    tmplist.sort()  ## sort them from the smallest to the greater 1,2,3...
    tmplist.reverse() ## reverse the order of the list ...3,2,1
    return [x for (key,x) in tmplist]

def sellOrder(self,par):
    "it orders the sell side of the book from the lowest price to the highest"
    tmplist = [(x.m,x) for x in par]
    tmplist.sort()
    return [x for (key,x) in tmplist]
            
## (5) The function called by the chartist to compute the the buy sell strategy

def signal(self, pl):
        '''
        The signal now occurs only when the short ma cross the long ma. I will compute
        each time the difference between the two. I register the difference of t-1 and will
        give a buy signal only when in t-1 the difference was negative and in t positive
        (crossing from below!!!)
        and a sell signal when in t-1 the difference was positive and in t negative
        (crossing from above!!!)

        '''


        self.previousDifferenceMa = self.differenceMa ## I register last difference
        ## compute the ma
        
        l = 5000
        s = 1000
        global sig
        a = 0
        for i in range(l):
            a += pl[i]
        maLong = a * l**-1

        b = 0
        for i in range(s):
            b+= pl[i]
        maShort = b * s**-1

           
        BuySellSignal = 0    
        self.differenceMa = maShort - maLong
        
        if self.previousDifferenceMa < 0 and self.differenceMa > 0: ##crossing from below!
            BuySellSignal = 1 ## positive signal --> BUY!
        
        if self.previousDifferenceMa > 0 and self.differenceMa < 0:
            BuySellSignal = -1 ## negative signal --> SELL!!

        #print self.previousDifferenceMa, self.differenceMa,BuySellSignal
        return BuySellSignal



## (6) Updater function. Called by Stock Market after a contract is made

def updateTraders(contract):
    "update number of equities and money owned by seller and buyer"
    contract.seller.money += contract.price
    contract.seller.equity -= 1
    contract.seller.sell += 1
    
    contract.buyer.money -= contract.price
    contract.buyer.equity += 1
    contract.buyer.buy += 1 

## (7) Report function. After the simulation is finished I am calling this function to r
##     all the local variables in the traders

def toReport(traderFList, traderCList, roboTrader):
    for i in traderFList:
                i.settime=now()
                i.wealth = i.money + i.equity * tb.aprice 
                datalist=[]
                datalist.append(i.indn)
                datalist.append(i.pf)
                datalist.append(i.equity)
                datalist.append(i.money)
                datalist.append(i.tradertype)
                datalist.append(i.buy)
                datalist.append(i.sell)
                datalist.append(i.wealth)
                datalist.append(i.settime)
                am.observe(datalist)  ## put the results in agentsf
                tm.observe(datalist)  ## put the results in finalAgents
                fm.observe(datalist)  ## only for fundamentalist tarders
    for i in traderCList:
                i.settime=now()
                i.wealth = i.money + i.equity * tb.aprice 
                datalist=[]
                datalist.append(i.indn)
                datalist.append(i.signal)
                datalist.append(i.equity)
                datalist.append(i.money)
                datalist.append(i.tradertype)
                datalist.append(i.buy)
                datalist.append(i.sell)
                datalist.append(i.wealth)
                datalist.append(i.settime)
                am.observe(datalist) 
                tm.observe(datalist)
                cm.observe(datalist)  ## only for chartist traders

    datalist = []
    i.settime=now()
    roboTrader.wealth = roboTrader.money + roboTrader.equity * tb.aprice 
    datalist.append(roboTrader.indn)
    datalist.append(roboTrader.signal)
    datalist.append(roboTrader.equity)
    datalist.append(roboTrader.money)
    datalist.append(roboTrader.tradertype)
    datalist.append(roboTrader.buy)
    datalist.append(roboTrader.sell)
    datalist.append(roboTrader.wealth)
    datalist.append(roboTrader.settime)
    am.observe(datalist) 
    tm.observe(datalist)
    rm.observe(datalist)##for the robot
    
## Start Market SIMULATION !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
## !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

print "Start Market Simulation---------"
print "--------------------------------"
initialize()
seed(initialSeed)
## tb = tradingBlackboard, a class
## tdbuy, tdsell e ts tradingDesk and Store, three sympy' STORE

## !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
## Start Market. We create tb, the TradingBlackboard !!!!!!!!!!!
## We create tdBuy, tdSell and ts. Than start Market !!!!!!!!!!!!!!!!!!!!!!
## Market scheduling: every five minuts read in ts and set tb !!
print "Start market--------------------"

tb =TradingBlackboard()

tdBuy =Store(name='buytradingdesk')  ## buy side of the book
tdBuy.addSort(buyOrder) ## ordering function for tdBuy. It activates when a new proposal arrives

tdSell=Store(name= 'selltradingdesk') ## sell side of the book
tdSell.addSort(sellOrder) ## ordering function for tdSell.

ts =Store(name='tradingstore')
sm =StockMarket("StockMarket")

proposalEvent = SimEvent('proposal') ## we create here the events, then they occur when the signal is fired by the traders
contractEvent = SimEvent('contract')

## activate the market simpy' process
activate(sm,sm.lifecycle(proposalEvent))

## Starting monitors
pm  =Monitor(name='p_Monitor')## Trading BlackBoard. Pm=prices monitor ---
pp = Monitor(name='p2_Monitor')
am  =Monitor(name='a_Monitor')## Record the trader, when it changes status
tdsm=Monitor(name='td_Monitor')
tickM = Monitor('observes tick prices')
tickRM = Monitor('observes tick returns')


tm=Monitor(name='Final Report')
fm=Monitor(name= 'final report fundamnetalists')
cm=Monitor(name='final report chartists')
rm = Monitor(name='final report robot')
bookM=Monitor(name='observe the book')



## Start trading. We activate nTraderF
fg = TraderFGenerator()
fc = TraderCGenerator()
fr = RoboTrader('RoboTrader')
## activate the traderF simpy' process
activate(fg,fg.generate())
activate(fc,fc.generate())
activate(fr, fr.lifecycle(contractEvent))

## Print process
pr = printPrice() 
activate(pr, pr.go())
pll = PlList()
activate(pll, pll.go())
#erasing old proposals process
er = ErasingOldProposals()
activate(er, er.go())

## Start Simulation //////////////////////////////////////////////////////

simulate(until=simTime)


########### REPORTING SIMULATED DATA#######################
print 'Reporting data'
print 'right signal', fr.sig * fr.totalSignals**-1
print 'benchmark', fr.bench* fr.totalSignals**-1
toReport(traderFList, traderCList, fr)



f=open('finalAgents.csv','w')
f.write('\n\nSTART SIMULATION'+'\n'+'run' + str(datetime.date.today()) + ' ' + str(time.localtime()[3]) + str(time.localtime()[4]) + str(time.localtime()[5]) + '\n')
f.write('\n number of fundamentalists:' + str(nTraderF) + 'number of chartists:' + str(nTraderC))
f.write("\n id,pf/ma,nr.equity,money,type,buy,sell,wealth,t, price \n")
for i in tm.yseries():
    datalist=[]
    datalist.append(repr(i[0]))
    datalist.append(repr(i[1]))
    datalist.append(repr(i[2]))
    datalist.append(repr(i[3]))
    datalist.append(repr(i[4]))
    datalist.append(repr(i[5]))
    datalist.append(repr(i[6]))
    datalist.append(repr(i[7]))
    datalist.append(repr(i[8]))
    datalist.append(repr(tb.aprice))
    datalist.append('\n')
    dataliststr=",".join(datalist)
    f.write(dataliststr)
    
f.close()


f=open('agentsf.csv','w')
f.write('\n\nSTART SIMULATION'+'\n'+'run' + str(datetime.date.today()) + ' ' + str(time.localtime()[3]) + str(time.localtime()[4]) + str(time.localtime()[5]) + '\n')
f.write('\n number of fundamentalists:' + str(nTraderF) + 'number of chartists:' + str(nTraderC))
f.write("\n id,pf/ma,nr.equity,money,type,buy,sell,wealth,t \n")
for i in am.yseries():
    datalist=[]
    datalist.append(repr(i[0]))
    datalist.append(repr(i[1]))
    datalist.append(repr(i[2]))
    datalist.append(repr(i[3]))
    datalist.append(repr(i[4]))
    datalist.append(repr(i[5]))
    datalist.append(repr(i[6]))
    datalist.append(repr(i[7]))
    datalist.append(repr(i[8]))
    datalist.append('\n')
    dataliststr=",".join(datalist)
    f.write(dataliststr)
    
f.close()


f=open('price.csv','w')

f.write('\n\nSTART SIMULATION'+'\n'+'run' + str(datetime.date.today()) + str(time.localtime()[3]) + str(time.localtime()[4]) + str(time.localtime()[5]) + '\n')
f.write('\n  nr f:' + str(nTraderF) + '  nr c:' + str(nTraderC)+'\n')
f.write('\n variance:'+str(pp.var())+ ' mean price:'+str(pp.mean())+'\n')
f.write("\n time, price, volume, sum  of abs(returns) \n")


for i in pm.yseries():
    datalist=[]
    datalist.append(repr(i[0]))
    datalist.append(repr(i[1]))
    datalist.append(repr(i[2]))
    datalist.append(repr(i[3]))
    datalist.append('\n')
    dataliststr=",".join(datalist)
    
    f.write(dataliststr)
    
f.close()

dtickPrice = []

for i in range(1, len(tickPrice)):
               a = tickPrice[i] - tickPrice[i-1]
               dtickPrice.append(a*tickPrice[i-1]**-1)
              
f= open('price.txt','w')
for i in dtickPrice:
    datalist=[]
    
    datalist.append(repr(i))
    
    datalist.append('\n')
    dataliststr="".join(datalist)
    
    f.write(dataliststr)
    
f.close()


f=open('book.csv','w')
f.write('\n\nSTART SIMULATION'+'\n'+'run' + str(datetime.date.today()) + str(time.localtime()[3]) + str(time.localtime()[4]) + str(time.localtime()[5]) + '\n')
f.write('\n  nr f:' + str(nTraderF) + '  nr c:' + str(nTraderC)+'\n')
f.write("time,Proposal in Sell, Proposal in Buy, tstore, price \n")
for i in tdsm.yseries():
    datalist=[]
    datalist.append(repr(i[0]))
    datalist.append(repr(i[1]))
    datalist.append(repr(i[2]))
    datalist.append(repr(i[3]))
    datalist.append(repr(i[4]))
    datalist.append('\n')
    dataliststr=",".join(datalist)
    f.write(dataliststr)
    
f.close()

########################### R functions ######################################

priceSerie = [] ## price
for i in pp:
    priceSerie.append(i[1])

wealthSerie = []## returns
for i in tm.yseries():
    wealthSerie.append(((i[7]-1100000)*1100000**-1)*100)
wealthSerie.sort()


FwealthSerie= [] ## returns of the fundamentalist
for i in fm.yseries():
    FwealthSerie.append(((i[7]-1100000)*1100000**-1)*100)
FwealthSerie.sort()


CwealthSerie = [] ## returns of the chartist
for i in cm.yseries():
    CwealthSerie.append(((i[7]-1100000)*1100000**-1)*100)
CwealthSerie.sort()

robotraderWealth = (tm.yseries()[len(tm.yseries())-1][7]-1100000)*1100000**-1



rpy.r.ts(priceSerie)
dpriceSerie = []
for i in range(1, len(priceSerie)):
    a = priceSerie[i]-priceSerie[i-1]
    dpriceSerie.append(a*priceSerie[i-1]**-1)




'''
dtickPrice = []
for i in range(1, len(tickPrice)):
               a = tickPrice[i] - tickPrice[i-1]
               dtickPrice.append(a)
'''
rpy.r.ts(tickPrice)
rpy.r.ts(dtickPrice)

varTickPrice = str(tickM.var())
varTickRet = str(tickRM.var())
print varTickPrice
print varTickRet
varprice = str(pp.var())
meanprice = str(pp.mean())

#rpy.r.par(mfrow=(2,1))
#rpy.r.ts_plot(tickPrice, main = "variance price = "+ varprice + "\n mean price = " + meanprice,  type='l', xlab='time 1 = 30 sec',ylab='price')
#rpy.r.ts_plot(dtickPrice, main = "returns",  type='l', xlab='time 1 = 30 sec',ylab=' returns')


rpy.r.par(mfrow=(2,1))
rpy.r.ts_plot(priceSerie, main = "variance price = "+ varTickPrice + "\n mean price = " + meanprice,  type='l', xlab='time 1 = 30 sec',ylab='price')
#rpy.r.acf(priceSerie, main="Price Correlogram", type="cor")
#rpy.r.acf(priceSerie, main="Price Partial Correlogram", type="par")


rpy.r.ts_plot(dpriceSerie, main = "variance returns= " + varTickRet,  type='l', xlab='time 1 = 30 sec',ylab=' returns')
#rpy.r.acf(dpriceSerie, main="returns Correlogram", type="cor")
#rpy.r.acf(dpriceSerie, main="returns Partial Correlogram", type="par")

'''
rpy.r.par(mfrow=(2,3))
rpy.r.ts_plot(priceSerie, main = "variance price = "+ varprice + "\n mean price = " + meanprice,  type='l', xlab='time 1 = 30 sec',ylab='price')
rpy.r.acf(priceSerie, main="Price Correlogram", type="cor")
rpy.r.acf(priceSerie, main="Price Partial Correlogram", type="par")
rpy.r.hist(wealthSerie,main="Distribution of the returns ",xlab="returns")
#rpy.r.plot(wealthSerie, ylab = 'returns', main="Distribution of returns")    
rpy.r.hist(FwealthSerie,main="Distribution of the returns \n of the Fundamentalists",xlab="returns")
rpy.r.hist(CwealthSerie,main="Distribution of the returns \n of the chartists",xlab="returns")
'''
## to save the graph

